﻿using Kivii.Sample.ImageUploader.Entities;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Sample.ImageUploader
{
    [Route(Configs.RouteReportRequest, "Get,Post")]
    internal class ReportRequest : IReturn<RestfulQueryResponse<Report>>
    {
        public string ReportId { get; set; }
    }

    [Route(Configs.RouteDbFileRequest, "Get,Post")]
    internal class DbFileRequest : IReturn<RestfulQueryResponse<DbFile>>
    {
        public Guid OwnerKvid { get; set; }
        public string FolderPath { get; set; } = "/Samples/Images";
        public string FolderType { get; set; } = "Jst.Lims.Entities.Sample";
        public string OrderBy { get; set; } = "CreateTime";
    }

    [Route(Configs.RouteDbFileDeleteRequest, "Get,Post")]
    internal class DbFileDeleteRequest : IReturn<RestfulDeleteResponse<DbFile>>
    {
        public List<Guid> Kvids { get; set; }
        public string FolderPath { get; set; } = "/Samples/Images";
        public string FolderType { get; set; } = "Jst.Lims.Entities.Sample";
    }

    [Route(Configs.RouteFilesUploadAndDownload, "Get,Post")]
    public class FileUploadRequest : FileRequestBase, IReturn<FileResponse>
    {
    }


    public class FileRequestBase
    {
        //public bool Override { get; set; }
        //public string Description { get; set; }
        public Guid OwnerKvid { get; set; }
        //public string OwnerName { get; set; }
        //public string Name { get; set; }
        public string FolderPath { get; set; }
        public string FolderType { get; set; }
        public string Tags { get; set; }
    }

    public class DbFile : Entity
    {
        public Bitmap Image { get; set; }
        public string Name { get; set; }

        public DbFile(Bitmap image, string name)
        {
            Image = image;
            Name = name;
        }

        public string Extension { get; set; }
        public long Length { get; set; }
        public DateTime PublishTime { get; set; }
        public string RemoteUrl { get; set; }
        public decimal Version { get; set; }
        public string Folder { get; set; }
        public string Path { get; set; }
        public string OwnerName { get; set; }
        public Guid OwnerKvid { get; set; }
        public string Tags { get; set; }
        public Guid CreatorKvid { get; set; }
        public string CreatorName { get; set; }
    }

    public class FileResponse : RestfulCreateResponse<DbFile>
    {
        public bool success
        {
            get
            {
                return ResponseStatus == null;
            }
        }
    }

}
